
/*****************************************************************************
                          E R I N A - L i b r a r y
                                                        ŏIXV 2001/5/23
 ----------------------------------------------------------------------------
         Copyright (C) 2000-2001 Leshade Entis. All rights reserved.
 *****************************************************************************/


#if	!defined(CXMIO_H_INCLUDE)
#define	CXMIO_H_INCLUDE

#if	!defined(ERIMATRIX_H_INCLUDE)
#include "erimatrix.h"
#endif

#if	!defined(CMPERI_H_INCLUDE)
#include "cmperi.h"
#endif


/*****************************************************************************
                                
 *****************************************************************************/

struct	MIO_INFO_HEADER
{
	DWORD	dwVersion ;
	DWORD	fdwTransformation ;
	DWORD	dwArchitecture ;
	DWORD	dwChannelCount ;
	DWORD	dwSamplesPerSec ;
	DWORD	dwBlocksetCount ;
	DWORD	dwSubbandDegree ;
	DWORD	dwAllSampleCount ;
	DWORD	dwLappedDegree ;
	DWORD	dwBitsPerSample ;
} ;

struct	MIO_DATA_HEADER
{
	BYTE	bytVersion ;
	BYTE	bytFlags ;
	BYTE	bytReserved1 ;
	BYTE	bytReserved2 ;
	DWORD	dwSampleCount ;
} ;

#define	MIO_LEAD_BLOCK	0x01


/*****************************************************************************
                            kIuWFNg
 *****************************************************************************/

class	MIOEncoder
{
protected:
	MIO_INFO_HEADER		m_mioih ;				// wb_

	unsigned int		m_nBufLength ;			// obt@iTvj
	void *				m_ptrBuffer1 ;			// obt@
	void *				m_ptrBuffer2 ;			// ёւobt@
	SBYTE *				m_ptrBuffer3 ;			// C^[[upobt@
	REAL32 *			m_ptrSamplingBuf ;		// TvOpobt@
	REAL32 *			m_ptrInternalBuf ;		// ԃobt@
	REAL32 *			m_ptrWorkBuf ;			// DCT Zp[NGA
	REAL32 *			m_ptrWeightTable ;		// eg̏d݃e[u
	REAL32 *			m_ptrLastDCT ;			// OubN DCT W

	double				m_rLowWeight ;			// g̏d
	double				m_rMiddleWeight ;		// g̏d
	double				m_rPowerScale ;			// ʎq̊rbg
	int					m_nOddWeight ;			// ubNc΍W

	SWORD *				m_ptrNextDstBuf ;		// o̓obt@AhX
	REAL32 *			m_ptrLastDCTBuf ;		// dZpobt@
	unsigned int		m_nSubbandDegree ;		// s̃TCY
	unsigned int		m_nDegreeNum ;
	int					m_nFrequencyWidth[7] ;	// egт̕
	int					m_nFrequencyPoint[7] ;	// egт̒Sʒu
	SIN_COS *			m_pRevolveParam ;

public:
	// \z֐
	MIOEncoder( void ) ;
	// Ŋ֐
	virtual ~MIOEncoder( void ) ;

	// ip[^̐ݒj
	int Initialize( const MIO_INFO_HEADER & infhdr ) ;
	// IỉȂǁj
	void Delete( void ) ;
	// k
	int EncodeSound
		( RLHEncodeContext & context,
			const MIO_DATA_HEADER & datahdr, const void * ptrWaveBuf ) ;
	// kIvVݒ
	void SetCompressionParameter
		( double rLowWeight = 16.0,
			double rMiddleWeight = 8.0,
			double rPowerScale = 0.5,
			int nOddWeight = 1 ) ;

protected:
	// 8rbgPCMk
	int EncodeSoundPCM8
		( RLHEncodeContext & context,
			const MIO_DATA_HEADER & datahdr, const void * ptrWaveBuf ) ;
	// 16rbgPCMk
	int EncodeSoundPCM16
		( RLHEncodeContext & context,
			const MIO_DATA_HEADER & datahdr, const void * ptrWaveBuf ) ;

protected:
	// sTCY̕ύXɔp[^̍ČvZ
	void InitializeWithDegree( unsigned int nSubbandDegree ) ;
	// wTv̉ʂ߂
	double EvaluateVolume( const REAL32 * ptrWave, int nCount ) ;
	// R[h擾
	int GetDivisionCode( void ) ;
	// 16rbg̔tk
	int EncodeSoundDCT
		( RLHEncodeContext & context,
			const MIO_DATA_HEADER & datahdr, const void * ptrWaveBuf ) ;
	// LOT ϊ{
	void PerformLOT
		( RLHEncodeContext & context,
			REAL32 * ptrSamples, REAL32 rPowerScale ) ;
	// ʏ̃ubN𕄍ďo͂
	int EncodeInternalBlock
		( RLHEncodeContext & context,
			REAL32 * ptrSamples, REAL32 rPowerScale ) ;
	// [hubN𕄍ďo͂
	int EncodeLeadBlock
		( RLHEncodeContext & context,
			REAL32 * ptrSamples, REAL32 rPowerScale ) ;
	// |XgubN𕄍ďo͂
	int EncodePostBlock
		( RLHEncodeContext & context, REAL32 rPowerScale ) ;
	// ʎq
	void Quantumize
		( PINT ptrQuantumized, const REAL32 * ptrSource,
			int nDegreeNum, REAL32 rPowerScale,
			DWORD * ptrWeightCode, int * ptrCoefficient ) ;

} ;


/*****************************************************************************
                            WJIuWFNg
 *****************************************************************************/

class	MIODecoder
{
protected:
	MIO_INFO_HEADER		m_mioih ;				// wb_

	unsigned int		m_nBufLength ;			// obt@iTvj
	void *				m_ptrBuffer1 ;			// obt@
	void *				m_ptrBuffer2 ;			// ёւobt@
	SBYTE *				m_ptrBuffer3 ;			// C^[[upobt@
	PBYTE				m_ptrDivisionTable ;	// R[he[u
	SDWORD *			m_ptrWeightCode ;		// ʎqWe[u
	PINT				m_ptrCoefficient ;		//
	REAL32 *			m_ptrMatrixBuf ;		// s񉉎Zpobt@
	REAL32 *			m_ptrInternalBuf ;		// ԃobt@
	REAL32 *			m_ptrWorkBuf ;			// DCT Zp[NGA
	REAL32 *			m_ptrWorkBuf2 ;
	REAL32 *			m_ptrWeightTable ;		// eg̏d݃e[u
	REAL32 *			m_ptrLastDCT ;			// O DCT W

	PBYTE				m_ptrNextDivision ;		// ̕R[h
	SDWORD *			m_ptrNextWeight ;		// ̗ʎqW
	PINT				m_ptrNextCoefficient ;	//
	PINT				m_ptrNextSource ;		// ̓͐M
	REAL32 *			m_ptrLastDCTBuf ;		// dZpobt@
	unsigned int		m_nSubbandDegree ;		// s̃TCY
	unsigned int		m_nDegreeNum ;
	SIN_COS *			m_pRevolveParam ;
	int					m_nFrequencyPoint[7] ;	// egт̒Sʒu

public:
	// \z֐
	MIODecoder( void ) ;
	// Ŋ֐
	virtual ~MIODecoder( void ) ;

	// ip[^̐ݒj
	int Initialize( const MIO_INFO_HEADER & infhdr ) ;
	// IỉȂǁj
	void Delete( void ) ;
	// k
	int DecodeSound
		( RLHDecodeContext & context,
			const MIO_DATA_HEADER & datahdr, void * ptrWaveBuf ) ;

protected:
	// 8rbgPCMWJ
	int DecodeSoundPCM8
		( RLHDecodeContext & context,
			const MIO_DATA_HEADER & datahdr, void * ptrWaveBuf ) ;
	// 16rbgPCMWJ
	int DecodeSoundPCM16
		( RLHDecodeContext & context,
			const MIO_DATA_HEADER & datahdr, void * ptrWaveBuf ) ;

protected:
	// sTCY̕ύXɔp[^̍ČvZ
	void InitializeWithDegree( unsigned int nSubbandDegree ) ;
	// 16rbg̔tWJ
	int DecodeSoundDCT
		( RLHDecodeContext & context,
			const MIO_DATA_HEADER & datahdr, void * ptrWaveBuf ) ;
	// ʏ̃ubN𕜍
	int DecodeInternalBlock
		( RLHDecodeContext & context,
			SWORD * ptrDst, unsigned int nSamples ) ;
	// [hubN𕜍
	int DecodeLeadBlock
		( RLHDecodeContext & context ) ;
	// |XgubN𕜍
	int DecodePostBlock
		( RLHDecodeContext & context,
			SWORD * ptrDst, unsigned int nSamples ) ;
	// ʎq
	void IQuantumize
		( REAL32 * ptrDestination,
			const INT * ptrQuantumized, int nDegreeNum,
			SDWORD nWeightCode, int nCoefficient ) ;
	// 
	int DecodeSamples
		( RLHDecodeContext & context,
			INT * ptrQuantumized, unsigned int nCount ) ;

} ;


#endif
